"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.camelizePath = camelizePath;
exports.default = getPages;
exports.defaultOptions = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _deepmerge = _interopRequireDefault(require("deepmerge"));

var _lodash = _interopRequireDefault(require("lodash.camelcase"));

var _lodash2 = _interopRequireDefault(require("lodash.get"));

var _lodash3 = _interopRequireDefault(require("lodash.set"));

var _lodash4 = _interopRequireDefault(require("lodash.omit"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function camelizePath(path) {
  var extensions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return (path[0] === '/' ? path.slice(1) : path).split('/').map(function (p) {
    var part = p;
    extensions.forEach(function (ext) {
      part = part.replace(new RegExp(ext, 'g'), '');
    });
    return part[0] === ':' ? "$".concat((0, _lodash.default)(part.slice(1))) : (0, _lodash.default)(part);
  }).join('.');
}

var defaultOptions = {
  extensions: ['.html'],
  filters: ['component', 'routes'],
  childKey: 'routes',
  home: {
    page: 'home',
    path: '/'
  }
};
exports.defaultOptions = defaultOptions;

function getPages(routesConfig) {
  var pages = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultOptions;

  var _defaultOptions$optio = _objectSpread({}, defaultOptions, {}, options),
      extensions = _defaultOptions$optio.extensions,
      filters = _defaultOptions$optio.filters,
      childKey = _defaultOptions$optio.childKey,
      home = _defaultOptions$optio.home;

  var isRoutesMap = routesConfig instanceof Map;
  (0, _toConsumableArray2.default)(routesConfig).forEach(function (routeOrMap) {
    var routeUnfiltered = isRoutesMap ? routeOrMap[1] : routeOrMap;

    var _omit = (0, _lodash4.default)(routeUnfiltered, filters),
        path = _omit.path,
        pageAliases = _omit.page,
        route = (0, _objectWithoutProperties2.default)(_omit, ["path", "page"]);

    var page = _objectSpread({
      path: path
    }, route);

    var pageAliasList = pageAliases instanceof Array ? pageAliases : [pageAliases].filter(function (f) {
      return f;
    });

    if (path) {
      var camelCasePath = camelizePath(path, extensions);
      var camelCasePathList = camelCasePath.split('.');
      camelCasePathList.forEach(function (onePathDepth, i) {
        if (path === home.path) {
          if (!pageAliasList.length) {
            getMergeSet(pages, home.page, page);
          } else {
            pageAliasList.forEach(function (depth) {
              getMergeSet(pages, depth, page);
            });
          }
        } else if (i === 0 && i === camelCasePathList.length - 1) {
          [onePathDepth].concat((0, _toConsumableArray2.default)(pageAliasList)).filter(function (f) {
            return f;
          }).forEach(function (depth) {
            return getMergeSet(pages, depth, page);
          });
        } else if (i > 0 && i === camelCasePathList.length - 1) {
          var targetList = [camelCasePath].concat((0, _toConsumableArray2.default)(pageAliasList)).filter(function (f) {
            return f;
          });
          targetList.forEach(function (target) {
            return getMergeSet(pages, target, page);
          });
        }
      });
    }

    routeUnfiltered[childKey] && getPages(routeUnfiltered[childKey], pages, childKey);
  });
  return pages;
}

function getMergeSet(object, path, value) {
  if (path.indexOf('.') !== -1) {
    var val = (0, _lodash2.default)(object, path) || {};
    (0, _lodash3.default)(object, path, (0, _deepmerge.default)(val, value));
  } else {
    Object.assign(object, (0, _deepmerge.default)(object, (0, _defineProperty2.default)({}, path, value)));
  }
}