"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getRoutesMap;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/es/map");

require("core-js/features/symbol/for");

var _deepmerge = _interopRequireDefault(require("deepmerge"));

var _treeOperations = _interopRequireDefault(require("@yeutech-lab/tree-operations"));

var _RoutesMap = _interopRequireDefault(require("./RoutesMap"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var defaultOptions = {
  soft: false,
  childKey: 'routes'
};

function getRoutesMap(routesConfig) {
  var routesMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new _RoutesMap.default();
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultOptions;

  var _defaultOptions$optio = _objectSpread({}, defaultOptions, {}, options),
      childKey = _defaultOptions$optio.childKey,
      soft = _defaultOptions$optio.soft;

  var copy = (0, _toConsumableArray2.default)(routesConfig);

  var flattenRouteConfigList = _treeOperations.default.toFlatArray(copy, childKey);

  flattenRouteConfigList.forEach(function (route) {
    var path = route.path || route.from;

    if (routesMap.has(path)) {
      var existingData = routesMap.get(path);

      if (!soft) {
        if (existingData.component && route.component) {
          throw new Error("You can't set more than 1 component per path (".concat(path, ")"));
        }

        if (route.name && existingData.name && route.name !== existingData.name) {
          throw new Error("You can't set a different name ".concat(existingData.name, " and ").concat(route.name, " for the route ").concat(path));
        }
      }

      routesMap.set(path, (0, _deepmerge.default)(existingData, route));
    } else if (path) {
      routesMap.set(path, route);
    }
  });
  return routesMap;
}

module.exports = exports.default;