"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makeRoutes;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _reactRouter = require("react-router");

var _react = _interopRequireDefault(require("react"));

function makeRoutes(routesConfig) {
  var childKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'routes';
  var r = routesConfig instanceof Map ? (0, _toConsumableArray2.default)(routesConfig.values()) : (0, _toConsumableArray2.default)(routesConfig);
  var routeList = [];

  function recursive(routes) {
    routes.forEach(function (route) {
      var path = route.path || route.from;

      if (!routeList.find(function (l) {
        return l.key === path;
      })) {
        if (route.from) {
          var to = route.to,
              push = route.push,
              from = route.from,
              exact = route.exact,
              strict = route.strict;
          routeList.push(_react.default.createElement(_reactRouter.Redirect, {
            key: from,
            to: to,
            push: push,
            from: from,
            exact: exact,
            strict: strict
          }));
        } else {
          var render = route.render,
              children = route.children,
              routePath = route.path,
              _exact = route.exact,
              _strict = route.strict,
              location = route.location,
              sensitive = route.sensitive,
              component = route.component;
          routeList.push(_react.default.createElement(_reactRouter.Route, {
            key: path,
            render: render,
            children: children,
            path: routePath,
            exact: _exact,
            strict: _strict,
            location: location,
            sensitive: sensitive,
            component: component
          }));
        }

        if (route[childKey]) {
          recursive(route[childKey]);
        }
      }
    });
  }

  recursive(r);
  return routeList;
}

module.exports = exports.default;