"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = matchParamsPath;

function matchParamsPath(path, pathWithParams) {
  var p1 = pathWithParams.split('/');
  var p2 = path.split('/');

  if (p1.length !== p2.length) {
    return false;
  }

  var leading = pathWithParams[0] === '/' ? '/' : '';
  var recomposedList = [];

  for (var i = 0; i < p2.length; i += 1) {
    if (p1[i] && p1[i].match(/:[-\w.]+/)) {
      recomposedList.push(p2[i]);
    } else if (p1[i]) {
      recomposedList.push(p1[i]);
    }
  }

  return "".concat(leading).concat(recomposedList.join('/')) === path;
}

module.exports = exports.default;