"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _Routes = _interopRequireDefault(require("../Routes"));

var testRoutes = [{
  name: 'home',
  path: '/',
  exact: true
}, {
  name: 'customers',
  path: '/customers.html',
  exact: true,
  routes: [{
    name: 'aboutUs',
    path: '/about-us.html',
    exact: true
  }, {
    name: 'career',
    path: '/career.html',
    exact: true
  }, {
    name: 'faq',
    path: '/faq.html',
    exact: true
  }, {
    name: 'cgu',
    path: '/CGU.html',
    exact: true
  }, {
    name: 'confidentiality',
    path: '/Confidentiality.html',
    exact: true
  }, {
    name: 'cookies',
    path: '/cookies.html',
    exact: true
  }]
}, {
  name: 'notFound',
  path: '/404.html'
}, {
  name: 'notFoundRedirect',
  from: '*',
  to: '/404.html'
}];

var renderComponent = function renderComponent(_ref) {
  var routes = _ref.routes,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["routes"]);
  return (0, _enzyme.shallow)(_react.default.createElement(_Routes.default, (0, _extends2.default)({
    routes: routes
  }, rest)));
};

describe('<Routes />', function () {
  it('should render a <Routes /> tag', function () {
    var renderedComponent = renderComponent({
      routes: testRoutes
    });
    expect(renderedComponent.length).toBe(1);
    expect(renderedComponent.find('Route').length).toBe(9);
    expect(renderedComponent.find('Redirect').length).toBe(1);
    var theRedirect = renderedComponent.find('Redirect');
    expect(theRedirect.prop('to')).toBe('/404.html');
  });
});