"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _RoutesMap = _interopRequireDefault(require("../RoutesMap"));

describe('RoutesMap', function () {
  it.only('should create a routes map', function () {
    var routesMap = new _RoutesMap.default([['/404.html', {
      name: 'notFound',
      path: '/404.html'
    }], ['/career.html', {
      name: 'career',
      path: '/career.html',
      exact: true
    }], ['/users/:id', {
      name: 'editUser',
      path: '/users/:id'
    }], ['/users/:userId/application/:id', {
      name: 'editUserApp',
      path: '/users/:userId/application/:id'
    }]]);
    expect(routesMap.get('/404.html').name).toBe('notFound');
    expect(routesMap.get('/career.html').exact).toBe(true);
    expect(routesMap.get('/users/:id').name).toBe('editUser');
    expect(routesMap.get('/users/1').name).toBe('editUser');
    expect(routesMap.get('/users/mikeordan/application/1337').name).toBe('editUserApp');
    expect(routesMap.get('/users/mikeordan/1337')).toBeUndefined();
    expect(routesMap.get('/users/mikeordan/application')).toBeUndefined();
    var map = new Map();
    expect(routesMap instanceof Map).toBe(true);
    expect(routesMap instanceof _RoutesMap.default).toBe(true);
    expect(routesMap.constructor !== Map).toBe(true);
    expect(routesMap.constructor === _RoutesMap.default).toBe(true);
    expect(map instanceof Map).toBe(true);
    expect(!(map instanceof _RoutesMap.default)).toBe(true);
    expect(map.constructor === Map).toBe(true);
    expect(map.constructor !== _RoutesMap.default).toBe(true);
  });
});